﻿Imports EF_flex_CustomDropDown.DropDownForm

Public Class Form1

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        C1FlexGrid1.Cols("ContactTitle").Editor = C1DropDownControl1
        Dim frmChild As New DropDownForm
        frmChild.Show()
        frmChild.Hide()
    End Sub

    Dim Keydwn As Boolean = False

    Private Sub C1FlexGrid1_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles C1FlexGrid1.KeyDown

        If C1FlexGrid1.Col = 4 Then
            Keydwn = True
            'Filter records before the DropDown is opened
            ApplyFilter(sender, e.KeyData.ToString())
        End If
  
    End Sub

    Dim flag As Boolean = False

    Private Sub C1FlexGrid1_KeyUpEdit(ByVal sender As System.Object, ByVal e As C1.Win.C1FlexGrid.KeyEditEventArgs) Handles C1FlexGrid1.KeyUpEdit
        If Keydwn = True Then
            SendKeys.Send("{BACKSPACE}")
            flag = True
        End If
        If C1FlexGrid1.Col = 4 Then
            If e.KeyCode = Keys.Back Then
                flag = True
                Dim vs As C1.Win.Data.Entities.EntityViewSourceCollection = DirectCast(DirectCast(Me.C1DropDownControl1.DropDownForm.Controls(0), C1.Win.C1FlexGrid.C1FlexGrid).DataSource, C1.Win.Data.Entities.C1DataSource).ViewSources
                vs(0).FilterDescriptors.Clear()
            Else
                'Open the DropDown after a character is typed
                C1DropDownControl1.OpenDropDown()
                If flag = True Then
                    ApplyFilter(sender, e.KeyData.ToString())
                End If
            End If
        End If
    End Sub

    Private Sub C1FlexGrid1_SelChange(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles C1FlexGrid1.SelChange
        If C1FlexGrid1.Col = 4 Then
            'If the Selected cell changes
            'Clear all the previously set filter Descriptors 
            Dim vs = DirectCast(DirectCast(Me.C1DropDownControl1.DropDownForm.Controls(0), C1.Win.C1FlexGrid.C1FlexGrid).DataSource, C1.Win.Data.Entities.C1DataSource).ViewSources(0)
            vs.FilterDescriptors.Clear()
        End If
        
    End Sub

    'Apply Filtering in the ViewSource of the DropDown C1FlexGrid bound to C1DataSource
    Private Sub ApplyFilter(ByVal sender As Object, ByVal value As String)
        Dim vs = DirectCast(DirectCast(Me.C1DropDownControl1.DropDownForm.Controls(0), C1.Win.C1FlexGrid.C1FlexGrid).DataSource, C1.Win.Data.Entities.C1DataSource).ViewSources(0)

        vs.FilterDescriptors.Clear()

        'Create filterdescriptors to perform filtering in the ViewSource
        Dim fd As New C1.Data.DataSource.FilterDescriptor

        'Column on which Filetring has to be applied
        fd.PropertyPath = "Title"
        'Records which are to be filtered
        fd.Value = value

        fd.Operator = C1.Data.DataSource.FilterOperator.StartsWith
        vs.FilterDescriptors.Add(fd)


    End Sub
End Class
